#include "extern.h"

/* transfer from asignmentstmt to forall */
Node *transfer_to_forall(root)
Node *root;
{
 Node *new;

 new = make (FORALL_STMT);
 new->ForallStmt.Forall = &Forall;
 new->ForallStmt.Lp = &Lp;
 new->ForallStmt.ForallTripletSpecList = make_triplet(root);
 new->ForallStmt.OptScalarMaskExpr = NN;
 new->ForallStmt.Rp = &Rp;
 new->ForallStmt.Stmt = change_stmt(root);
 new->ForallStmt.statement = make ( STATEMENT);
 array_index_declare ();

 new = check_ForallStmt_down (new);
 new = check_ForallStmt (new);
 new->ForallStmt.statement =  new ;

 return new;
}

Node *make_triplet(root)
Node *root;
{
 Node *spec, *new;
 int i;
 new = make (FORALL_TRIPLET_SPEC_LIST);
 new = NN;
 for(i=0;i<root->com.typ->shape->rank; i++){
    spec = make (FORALL_TRIPLET_SPEC);
    spec->ForallTripletSpec.Name = array_index(i);
    spec->ForallTripletSpec.Eq = &Eq;
    spec->ForallTripletSpec.Expr = root->com.typ->shape->sizes0[i];
    spec->ForallTripletSpec.Colon = &Colon;
    spec->ForallTripletSpec.Expr1 = root->com.typ->shape->sizes1[i];
    spec->ForallTripletSpec.Colon1 = &Colon;
    spec->ForallTripletSpec.Expr2 = root->com.typ->shape->sizes2[i];
    new = list_add_beg(new, spec, SUBSCRIPT_LIST);
  }

 return new;
}

Node *change_stmt(root)
Node *root;
{
  Node *var = root->AssignementStmt.Variable;
  Node *expr = root->AssignementStmt.Expr;
  Node *sub, *temp, *ele;
  Etype *etype;
  int i;

  nelements = 0;
  Assg_elements[nelements]= var;
  nelements++;
  find_communication_elements ( expr);
  etype =   root->com.typ->etype;
  root->com.typ = typ_malloc();
  root->com.typ->etype = etype;
  root->com.typ->shape= shape_malloc();
  root->com.typ->shape->rank = 0;
  for(i=0; i<nelements; i++) {
   e_array_current = 0;
   ele =   Assg_elements[i];
   for (LIST_LOOP (sub, list_invert(ele->ArraySection.SubscriptList), temp)){
        change_Subscript(sub);
        sub->Subscript.Expr->com.typ = typ_malloc();
        sub->Subscript.Expr->com.typ->etype = Etype_INTEGER_0;
      }
  etype =   ele->com.typ->etype;
  ele->com.typ = typ_malloc();
  ele->com.typ->etype = etype;
  ele->com.typ->shape = shape_malloc();
  ele->com.typ->shape->rank = 0;
 }
  
 e_array_current = 0;
  return root;
}
